/* tst-inverst.c
    For full testing of `__ultoa_invert'.
    You must define begin value (BEGIN) and number of values (NVALS) (0 and
    0 is possible, but very long).
    Remember about max value: 4'294'967'295.
 2005-02-10	Begin.
*/
#include <stdlib.h>
#include <string.h>
#include "xtoa_fast.h"

int main ()
{
    unsigned long x = BEGIN;
    unsigned long nvals = NVALS;
    char s [sizeof("4000111222")];	/* for conversion result	*/
    char pattern [sizeof(s)];		/* for comparison		*/
    char *p;
    unsigned char r1;
    
    ultoa(x, pattern, 10);		/* no printf !	*/
    strrev(pattern);

    do {
	p = __ultoa_invert(x, s, 10);
	
	/* r1 ? (it is used)	*/
	asm ("mov %0,r1" : "=r"(r1));
	if (r1) exit(__LINE__);
	
	/* '\0' at the end ?	*/
	if (*p) exit(__LINE__);
	
	/* return value ?	*/
	if (p - s != (int)strlen(pattern)) exit(__LINE__);
	
	/* conversion result ?	*/
	if (strcmp(s, pattern)) exit(__LINE__);
	
	/* next value	*/
	x += 1;
	for (p = pattern; ++(*p) == '9' + 1; ) {
	    *p++ = '0';
	    if (!*p) *p = '0';
	}
    } while (--nvals);
    
    return 0;
}
/* eof */
